#include <avr/io.h>
#include <util/delay.h>

uint16_t read_adc(uint8_t channel)
{
    ADMUX = 0b01000000; 
    ADMUX |= channel; 
    ADCSRA = 0b11000110;
    while ((ADCSRA & (1<<ADSC)))
        ;
    return ADCL + ADCH*256;
}

int Mod5(int a) 
{
	if(a >= 5)
		return 0;
	if(a < 0)
		return a+5;
	return a;
}

int SET_LDR(int input,int LDR)
{
	if(LDR >= input)
		if(LDR - input <= 30)
			return LDR;
	if(input >= LDR)
		if(input - LDR <= 30)
			return LDR;
	return input;
}

main()
{
	int LDR = 0;
	DDRB = 0b00001111;
    PORTB = 0b11110000;
    DDRC = 0b00001011;
    PORTC = 0b00101111;
    int State = 0;
    int Light = 0;
    int a = 0;
    int b = 0;
    int c = 0;
    while(1)
    {
		if((PINB & 0b00100000) == 0)
		{
			while((PINB & 0b00100000) == 0)
				;
			_delay_ms(1000);
			State--;
		}
		if((PINB & 0b00010000) == 0)
		{
			while((PINB & 0b00010000) == 0)
				;
			_delay_ms(250);	
			State++;
		}
		a = b;
		b = c;
		c = read_adc(5);
		if(a-b >= 25 && c-b >= 25)
			State++;
		State = Mod5(State);
		LDR = SET_LDR(read_adc(5),LDR);
		if(State == 4) {			
			if(LDR < 500)
				Light = 3;
			else if(LDR >= 500 && LDR < 650)
				Light = 2;
			else if(LDR >= 650 && LDR < 800)
				Light = 1;
			else if(LDR >= 800)
				Light = 0;
			else
				Light = 0;
		}
		else if(State != 4)
			Light = State;
		if(Light == 0)
		{
			PORTB = 0b00110000;
			PORTC = 0b00100100;
		}
		else if(Light == 1)
		{
			PORTB = 0b00111000;
			PORTC = 0b00100101;
		}
		else if(Light == 2)
		{
			PORTB = 0b00111100;
			PORTC = 0b00100111;
		}
		else if(Light == 3)
		{
			PORTB = 0b00111110;
			PORTC = 0b00101111;
		}
		if(State == 4)
		{
			PORTB |= 0b00110001;
		}
		_delay_ms(250);
	}
}
